using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
namespace ChessEngine
{
    class Chess
    {
        public int[] start = {6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,
                               6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,
                               6 ,6 ,2 ,4 ,3 ,0 ,1 ,3 ,4 ,2 ,6 ,6 ,
                               6 ,6 ,5 ,5 ,5 ,5 ,5 ,5 ,5 ,5 ,6 ,6 ,
                               6 ,6 ,7 ,7 ,7 ,7 ,7 ,7 ,7 ,7 ,6 ,6 ,
                               6 ,6 ,7 ,7 ,7 ,7 ,7 ,7 ,7 ,7 ,6 ,6 ,
                               6 ,6 ,7 ,7 ,7 ,7 ,7 ,7 ,7 ,7 ,6 ,6 ,
                               6 ,6 ,7 ,7 ,7 ,7 ,7 ,7 ,7 ,7 ,6 ,6 ,
                               6 ,6 ,13,13,13,13,13,13,13,13,6 ,6 ,
                               6 ,6 ,10,12,11,8 ,9 ,11,12,10,6 ,6 ,
                               6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,
                               6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 ,6 };
        public int[] F_rating = {200, 9,5,3,3,1};

        public int[] move_arround = { 1, 13, 12, 11, -1, -13, -12, -11 };       //King
        public int[] move_knight =  { -25, -23, -10, 14, 25, 23, 10, -14 };             

        public int[] field;

        public BestMoves bestmoves;

        public Chess()
        {
            field = start;
            mov = new List<Move>();
            best = new Move[5];
            e = new Engine();
            bestmoves = new BestMoves();
        }

        public Move[] GetMoves(int movecolor)
        {
            List<Move> moves = new List<Move>();
            int x, y, z, wide, value, figure, target, color, feld;
            y = 7;
            do
            {
                x = 7;
                do
                {
                    color = 1;
                    feld = 26 + x + 12 * y; //Alle begebaren Felder durchgehen
                    if (field[feld] != 7)              //Ist das Feld auch nicht leer?
                    {
                        if ((figure = field[feld]) > 7)
                        {
                            color = -1;
                            figure -= 8;
                        }
                        if (color == movecolor)
                            switch (figure)
                            {
                                case 0: //King
                                    z = 7;
                                    do
                                    {
                                        if ((value = field[target = feld + move_arround[z]]) != 6)
                                            if (value == 7)
                                                moves.Add(new Move(feld, target));
                                            else if (value > 7 && color == 1 || value < 6 && color == -1)
                                                moves.Add(new Move(feld, target));

                                    }
                                    while (z-- != 0);
                                    break;
                                case 1:
                                    z = 7;
                                    do
                                    {
                                        wide = 0;
                                        while ((value = field[target = feld + move_arround[z] * ++wide]) != 6)
                                            if (value == 7)
                                                moves.Add(new Move(feld, target));
                                            else if (value > 7 && color == 1 || value < 6 && color == -1)
                                            {
                                                moves.Add(new Move(feld, target));
                                                break;
                                            }
                                            else
                                                break;
                                    }
                                    while (z-- != 0);
                                    break;
                                case 2:
                                    z = 8;
                                    do
                                    {
                                        z -= 2;
                                        wide = 0;
                                        while ((value = field[target = feld + move_arround[z] * ++wide]) != 6)
                                            if (value == 7)
                                                moves.Add(new Move(feld, target));
                                            else if (value > 7 && color == 1 || value < 6 && color == -1)
                                            {
                                                moves.Add(new Move(feld, target));
                                                break;
                                            }
                                            else
                                                break;
                                    }
                                    while (z != 0);
                                    break;
                                case 3:
                                    z = 9;
                                    do
                                    {
                                        z -= 2;
                                        wide = 0;
                                        while ((value = field[target = feld + move_arround[z] * ++wide]) != 6)
                                            if (value == 7)
                                                moves.Add(new Move(feld, target));
                                            else if (value > 7 && color == 1 || value < 6 && color == -1)
                                            {
                                                moves.Add(new Move(feld, target));
                                                break;
                                            }
                                            else
                                                break;
                                    }
                                    while (z != 1);
                                    break;
                                case 4:
                                    z = 7;
                                    do
                                    {
                                        if ((value = field[target = feld + move_knight[z]]) != 6)
                                            if (value == 7)
                                                moves.Add(new Move(feld, target));
                                            else if (value > 7 && color == 1 || value < 6 && color == -1)
                                                moves.Add(new Move(feld, target));
                                    }
                                    while (z-- != 0);
                                    break;
                                case 5:
                                    if ((value = field[target = feld + 12 * color]) == 7)
                                    {
                                        moves.Add(new Move(feld, target));
                                        if(y == 1 || y == 6)
                                            if ((value = field[target = feld + 24 * color]) == 7)
                                            moves.Add(new Move(feld, target));
                                    }
                                    if ((value = field[target = feld + 11 * color]) != 6 && value != 7 && (value > 7 && color == 1 || value < 6 && color == -1))
                                        moves.Add(new Move(feld, target));
                                    if ((value = field[target = feld + 13 * color]) != 6 && value != 7 && (value > 7 && color == 1 || value < 6 && color == -1))
                                        moves.Add(new Move(feld, target));
                                    break;
                                default: throw new Exception();
                            }
                    }
                }
                while (x-- != 0);
            }
            while (y-- != 0);
            return moves.ToArray();
        }

        public void DoMove(Move m)
        {
            Cmove++;
            field[m.To] = field[m.From];
            field[m.From] = 7;
        }

        public Move bestM;

        public int BestMove3(int color, int tiefe, int maxtiefe, int min)
        {
            int wert = 0;
            if (tiefe == maxtiefe)
                return Rate();
            Move[] zuege = GetMoves(color);
            foreach (Move move in zuege)
            {
                int oldTo = field[move.To];
                field[move.To] = field[move.From];
                field[move.From] = 7;
                for (int i = 0; i != tiefe; i++)
                    Console.Write("    ");
                Console.WriteLine(move.ToString());
                wert = BestMove3(-color, tiefe + 1, maxtiefe, min) * color;
                //Rckgngigmachen:
                field[move.From] = field[move.To];
                field[move.To] = oldTo;
                if (min == wert && tiefe == 0)
                {
                    bestM = move;
                    bestM.Rating = wert;
                }
                if (wert > min)
                {
                    min = wert;
                    if (tiefe == 0)
                    {
                        bestM = move;
                        bestM.Rating = wert;
                    }
                }
                if (wert < min)
                    return min;
            }
            return wert;
        }

        public Move DoMove4(int color, int depth)
        {
            List<Move> open = new List<Move>();
            open.AddRange(GetMoves(color));
            for (int i = 0; i != open.Count; i++)
                open[i].Rating = Rate(open[i]) * color;
            open.Sort();
            int[] save = new int[144];
            for (int x = 0; x < depth; x++ )
            {
                for (int i = 0; i != field.Length; i++)
                    save[i] = field[i];
                //int oldTo = field[open[0].To];
                //field[open[0].To] = field[open[0].From];
                //field[open[0].From] = 7;
                Stack<Move> st = new Stack<Move>();
                Move move = open[0];
                while (move != null)
                {
                    st.Push(move);
                    move = move.prev;
                }
                while(st.Count != 0)
                    DoMove(st.Pop());

                Move[] temp = GetMoves(color * (open[0].count % 2 == 0 ? -1 : 1));
                for (int i = 0; i != temp.Length; i++)
                {
                    temp[i].count = open[0].count + 1;
                    temp[i].prev = open[0];
                    temp[i].Rating = Rate(temp[i]) * color * (open[0].count % 2 == 0 ? -1 : 1);
                }
                //Rckgngigmachen:
                /*field[open[0].From] = field[open[0].To];
                field[open[0].To] = oldTo;*/
                for (int i = 0; i != field.Length; i++)
                    field[i] = save[i];
                open.RemoveAt(0);
                open.AddRange(temp);
                open.Sort();
            }
            Move tmp = open[0];
            while ((tmp.prev) != null)
            {
                Console.Write(tmp.ToString() + " << ");
                tmp = tmp.prev;
            }
            /*Console.WriteLine(m.ToString());
            Move tmp = open[0];
            while ((tmp.prev) != null) tmp = tmp.prev;*/
            return tmp;
        }

        Move aktmove;
        public Move endmove;
        int startcolor;
        int startdepth;
        public Move AB(int color, int depth)
        {
            mov.Clear();
            e.treeView1.Nodes.Clear();
            bestmoves.listView1.Items.Clear();
            ts = new TreeSave(new Move(0,0));
            endmove = null;
            startcolor = color; //startcolor = 1;
            startdepth = depth;
            maxdepth = 4;
            int wert;
                if (color == 1)
                    wert = Max(color, -1000, 1000, 0, ref ts);
                else
                    wert = Min(color, -1000, 1000, 0, ref ts);

                //wert = Max(color, -1000, 1000, 0, ref ts);
            Console.WriteLine("Zug Wertung: " + Max(color, -1000, 1000, 0, ref ts));
            
            //AlphaBeta(depth, -1000,1000);
            e.treeView1.Nodes.AddRange(getNode(ts));
            mov.Sort();
            for(int i = 0; i!= mov.Count; i++)
                bestmoves.listView1.Items.Add(new ListViewItem(new string[]{mov[i].ToPlayer(),mov[i].ToMove(),((float)mov[i].Rating / 10).ToString()}));
            return mov[0];
        }


        public TreeNode[] getNode(TreeSave t)
        {
            if (t == null)
                return new TreeNode[] { new TreeNode("Nothing") };
            if (t.ts == null)
                return new TreeNode[] { new TreeNode(t.m.ToString()) };
            List<TreeNode> tn = new List<TreeNode>();
            for (int i2 = 0; i2 < t.ts.Length; i2++)
            {
                if (t.ts[i2] == null)
                    break;
                tn.Add(new TreeNode(t.ts[i2].m.ToString(), getNode(t.ts[i2])));
            }
            return tn.ToArray();
        }

        int AlphaBeta(int tiefe, int alpha, int beta)
        {
            int wert;
            if (tiefe == 0) return Rate() * ((startdepth - tiefe) % 2 == 0 ? 1 : -1) * startcolor;
            Move[] moves = GetMoves(((startdepth - tiefe) % 2 == 0 ? 1 : -1) * startcolor);
            for (int i = 0; i != moves.Length; i++)
            {
                int oldTo = field[moves[i].To];
                field[moves[i].To] = field[moves[i].From];
                field[moves[i].From] = 7;
                wert = -AlphaBeta(tiefe - 1, -beta, -alpha);
                moves[i].Rating = wert;
                //Rckgngigmachen:
                field[moves[i].From] = field[moves[i].To];
                field[moves[i].To] = oldTo;
                if (wert >= beta)
                {
                    if (tiefe == startdepth)
                        endmove = moves[i];
                    return beta;
                }
                if (wert > alpha)
                    alpha = wert;
            }
            if (tiefe == startdepth)
            {
                Array.Sort(moves);
                endmove = moves[0];
            }
            return alpha;
        }

        int maxdepth = 4;

        int Min(int color, int alpha, int beta, int depth, ref TreeSave t)
        {
            if (depth == maxdepth)
                return Rate();
            Move[] moves = GetMoves(color);
            t.ts = new TreeSave[moves.Length];
            for (int i = 0; i != moves.Length; i++)
            {
                t.ts[i] = new TreeSave(moves[i]);
                int oldTo = field[moves[i].To];
                field[moves[i].To] = field[moves[i].From];
                field[moves[i].From] = 7;
                int wert = Max(color * -1, alpha, beta, depth + 1, ref t.ts[i]);
                t.ts[i].m = new Move(moves[i], wert, depth + 1, "Alpha = " + alpha + "; Beta = " + beta + " {" + wert + " = Max(" + color * -1 + ", " + alpha + ", " + beta + ", " + "depth + 1" + ", ref t.ts[i])" + "}");
                if (depth == 0)
                    mov.Add(new Move(moves[i], wert, depth + 1));
                //Rckgngigmachen:
                field[moves[i].From] = field[moves[i].To];
                field[moves[i].To] = oldTo;
                if (wert <= alpha)
                   return wert;
                if (wert < beta)
                    beta = wert;
            }

            return beta;
        }

        public List<Move> mov;

        public Engine e;
        TreeSave ts;

        public System.Windows.Forms.TreeNode GotoNext(ref System.Windows.Forms.TreeNode tn, int i)
        {
            return tn.Nodes[i];
        }

        int Max(int color, int alpha, int beta, int depth, ref TreeSave t)
        {
            if (depth == maxdepth)
                return Rate();
            Move[] moves = GetMoves(color);
            t.ts = new TreeSave[moves.Length];
            for (int i = 0; i != moves.Length; i++)
            {
                t.ts[i] = new TreeSave(moves[i]);
                int oldTo = field[moves[i].To];
                field[moves[i].To] = field[moves[i].From];
                field[moves[i].From] = 7;
                int wert = Min(color * -1, alpha, beta, depth + 1, ref t.ts[i]);
                t.ts[i].m = new Move(moves[i], wert, depth + 1, "Alpha = " + alpha + "; Beta = " + beta + " {" + wert + " = Min("+color * -1+", "+alpha+", "+beta+", "+"depth + 1"+", ref t.ts[i])"+"}");
                if (depth == 0)
                    mov.Add(new Move(moves[i], wert, depth + 1));
                //Rckgngigmachen:
                field[moves[i].From] = field[moves[i].To];
                field[moves[i].To] = oldTo;
                if (wert >= beta)
                    return wert;
                if (wert > alpha)
                    alpha = wert;

            }
            return alpha;
        }


        public int AlphaBeta(int color, int depth, int alpha, int beta)
        {
            if (depth == 0)
                return Rate();
            int wert;
            Move[] zuege = GetMoves(color);
            foreach (Move move in zuege)
            {
                if(depth == startdepth)
                    aktmove = move;
                int oldTo = field[move.To];
                field[move.To] = field[move.From];
                field[move.From] = 7;

                wert = AlphaBeta(-color, depth - 1, -alpha, -beta);

                field[move.From] = field[move.To];
                field[move.To] = oldTo;
                if (wert > alpha)
                {
                    if(startcolor == color)
                        endmove = aktmove;
                    alpha = wert;
                }
                if (alpha >= beta)
                {
                    if (startcolor == color)
                        endmove = aktmove;
                    return alpha;
                }
            }
            return alpha;
        }

        public int AlphaBeta(int color, int tiefe, int maxtiefe, int alpha, int beta)
        {
            int wert;
            if (tiefe == maxtiefe)
                return Rate();
            Move[] zuege = GetMoves(color);
            foreach(Move move in zuege)
            {
                if (tiefe == 0)
                    aktmove = move;
                int oldTo = field[move.To];
                field[move.To] = field[move.From];
                field[move.From] = 7;
                
                wert = AlphaBeta(color * -1,tiefe + 1, maxtiefe, alpha, beta);
                move.Rating = wert;
                for (int i = 0; i != tiefe; i++)
                    Console.Write("    ");
                Console.WriteLine(move.ToString());
                //Rckgngigmachen:
                field[move.From] = field[move.To];
                field[move.To] = oldTo;

                if (color == startcolor) //MAX
                {
                    if (wert > alpha)
                    {
                        if (startcolor == color)
                            endmove = aktmove;
                        alpha = wert;
                    }
                    if (alpha >= beta) //MINI
                    {
                        if (startcolor == color)
                            endmove = aktmove;
                        return alpha;
                    }

                }
                else
                {
                    if (wert < alpha)
                    {
                        if (startcolor == color)
                            endmove = aktmove;
                        alpha = wert;
                    }
                    if (alpha <= beta)
                    {
                        if (startcolor == color)
                            endmove = aktmove;
                        return alpha;
                    }
                }
            }
            return alpha;
        }


        public Move DoBestMove(int movecolor)
        {
            Move temp = BestMove(movecolor, 0,2);
            DoMove(temp);
            return temp;    
        }

        int Cmove = 0;

        public Move BestMove(int movecolor)
        {
            DateTime now = DateTime.Now;
            Move[] moves = GetMoves(movecolor);
            if (moves.Length == 0)
            {
                Console.WriteLine("PATT!");
                while (true) ;
            }
            int value = -12000;
            Move bm = null;
            foreach (Move m in moves)
            {
                int temp = Rate(m)*movecolor;
                Console.WriteLine("-" + m.ToString() + ": " + (float)temp / 10 * movecolor);
                if (bm == null)
                {
                    bm = m;
                    value = temp;
                }
                if (temp > value)
                {
                    value = temp;
                    bm = m;
                }
            }
            Console.Write(""+(Cmove/2+1)+". [" + (now - DateTime.Now).ToString() + "] " + (float)value * movecolor / 10 + ": ");
            return bm;
        }


        public Move BestMove(int color, int iterator, int depth)
        {
            Move[] moves = GetMoves(color);
            Move ret = null;
            int value = -10000;
            Move temp;                
            foreach (Move move in moves)
            {
                int oldTo = field[move.To];
                field[move.To] = field[move.From];
                field[move.From] = 7;
                if (iterator < depth)
                    temp = BestMove(color * -1, iterator + 1,depth);
                else
                    temp = new Move(move, Rate());
                if (temp.Rating * color >= value)
                {
                    ret = new Move(move, temp.Rating);
                    value = temp.Rating * color;
                }

                //Rckgngigmachen:
                field[move.From] = field[move.To];
                field[move.To] = oldTo;
            }
            return ret;
        }
         public Move[] best;

        public Move BestMove2(int color, int iterator)
        {
            if (iterator == 0)
                for (int i = 0; i != 5; i++)
                    best[i] = null;
            Move[] moves = GetMoves(color);
            Move[] temp = new Move[moves.Length];
            for(int i = 0; i!= moves.Length; i++)
            {
                moves[i].Rating = Rate(moves[i])*color;
            }
            Array.Sort(moves);
            if (iterator > 1 && moves[0].Rating < 1 || iterator == 3)
                return moves[0];
            for (int i = 0; i < moves.Length; i++)
            {
                int oldTo = field[moves[i].To];
                field[moves[i].To] = field[moves[i].From];
                field[moves[i].From] = 7;

                temp[i] = BestMove2(color * -1, iterator + 1);
                temp[i].From = moves[i].From;
                temp[i].To = moves[i].To;

                field[moves[i].From] = field[moves[i].To];
                field[moves[i].To] = oldTo;
            }
            Array.Sort(temp);
            if (iterator == 0)
                for (int i = 0; i != 5; i++)
                    best[i] = temp[i];
            return temp[0];
        }

        public int Rate(Move m)
        {
            int oldTo = field[m.To];
            field[m.To] = field[m.From];
            field[m.From] = 7;
            //Jetzt rechnen wir ab:
            int rating = 0, value, x, y; //rating muss int16 sein!!!
            //Erst mal die Figurenwerte
            y = 7;
            do
            {
                x = 7;
                do
                {
                    int feld = 26 + x + 12 * y;
                    if ((value = field[feld]) < 6)
                        rating += F_rating[value] * 10;
                    else if (value > 7)
                        rating -= F_rating[value - 8] * 10;
                }
                while (x-- != 0);
            }
            while (y-- != 0);
            //jetzt die Beweglichkeit:
            rating += GetMoves(1).Length;
            rating -= GetMoves(-1).Length;
            //Rckgngigmachen:
            field[m.From] = field[m.To];
            field[m.To] = oldTo;
            return rating;
        }
        public int Rate()
        {
            //Jetzt rechnen wir ab:
            int rating = 0, value, x, y; //rating muss int16 sein!!!
            //Erst mal die Figurenwerte
            y = 7;
            do
            {
                x = 7;
                do
                {
                    int feld = 26 + x + 12 * y;
                    if ((value = field[feld]) < 6)
                        rating += F_rating[value] * 10;
                    else if (value > 7)
                        rating -= F_rating[value - 8] * 10;
                }
                while (x-- != 0);
            }
            while (y-- != 0);
            //jetzt die Beweglichkeit:
            rating += GetMoves(1).Length;
            rating -= GetMoves(-1).Length;
            return rating;
        }
    }

    public class Move : IComparable
    {
        int from, to, rating;
        public Move prev;
        public int count, move;
        string info;
        public Move(int from, int to)
        {
            count = 0;
            this.from = from;
            this.to = to;
            rating = 0;
            prev = null;
            info = "";
        }


        public Move(Move m, int rating)
        {
            move = 1;
            from = m.from;
            to = m.to;
            this.rating = rating;
            info = "";


        }

        public Move(Move m, int rating ,int move)
        {
            this.move = move;
            from = m.from;
            to = m.to;
            this.rating = rating;
            info = "";
        }
        public Move(Move m, int rating, int move, string i)
        {
            this.move = move;
            from = m.from;
            to = m.to;
            this.rating = rating;
            info = i;
        }

        string abc = "HGFEDCBA";

        public override string ToString()
        {
            if (from == to && to == 0)
                return "URNODE";
            return  ToPlayer() + " " + ToMove() + " [" + (float)rating / 10 + "]" + " :: " + info;
        }

        public string ToMove()
        {
            return abc[from % 12 - 2].ToString() + (from / 12 - 1) + " - " + abc[to % 12 - 2].ToString() + (to / 12 - 1);
        }

        public string ToPlayer()
        {
            //return ((move % 2) == 1 ? ((move + 1) / 2 + ".") : (move / 2 + ". ..."));
            return move.ToString();
        }

        public bool IsEqual(Move m)
        {
            if (m.to == to && m.from == from)
                return true;
            return false;
        }

        public int From
        {
            get
            {
                return from;
            }
            set
            {
                from = value;
            }
        }
        public int To
        {
            get
            {
                return to;
            }
            set
            {
                to = value;
            }
        }

        public int Rating
        {
            get
            {
                return rating;
            }
            set
            {
                rating = value;
            }
        }

        public int CompareTo(object obj)
        {
            return ((Move)obj).rating.CompareTo(rating);
        }
    }

    public enum Figure
    {
        W_King = 0, W_Queen = 1, W_Rook = 2,  W_Bishop = 3,  W_NKnight = 4,  W_Pawn = 5,
        B_King = 8, B_Queen = 9, B_Rook = 10, B_Bishop = 11, B_NKnight = 12, B_Pawn = 13, 
        
        OutOfField = 6,  Empty = 7,
    }

    class TreeSave
    {
        public TreeSave[] ts;
        public Move m;
        public TreeSave(Move m)
        {
            this.m = m;
        }
    }
}
